#include "testlib.h"

const long long INF = 4294967295;

/*
 * Аргументы (Обязательные): <I> <N> <START> <START_STEP>
 * Дополнительные: <вес для N> [если есть вес, то - rnd(1, n)]
 * Тест: Первый шаг большой, а потом значение спускается, не теряя ни одного кольца
*/


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(2);
    if (argc > 5) {
        n = rnd.wnext(1, n, opt<int>(5));
    }
    long long max = 100000000 / n;
    println(n);
    long long start = opt<int>(3) + opt<int>(1) * opt<int>(4), now = 0, temp;
    bool up;
    while (n) {
        --n;
        println('+', start);
        now += start;
        long long last = now;
        if (!n) {
            break;
        }
        --n;
        temp = rnd.wnext(1ll, std::min(max, now - 1), -10);
        println('-', temp);
        now -= temp;
        while (n) {
            up = rnd.next(0, 1) && (last > now);
            if (up) {
                temp = rnd.next(1ll, std::min(max, last - now));
                last = now;
                now += temp;
            } else {
                temp = rnd.next(1ll, std::min(max, now - 1));
                last = now;
                now -= temp;
            }
            println(up ? '+' : '-', temp);
            --n;
            if (now == 1) {
                break;
            }
        }
    }
}
