#include "testlib.h"

const long long INF = 4294967295;

/*
 * Аргументы (Обязательные): <значение N>
 * Тест: Специально для больших чисел (шаг максимум 10)
*/


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(2);
    println(n);

    long long now = 0, temp;
    bool up;
    for (int i = 0; i < n; ++i) {
        up = (rnd.next(0, 1) || now <= 1) && now != INF;
        if (up) {
            temp = rnd.next(1ll, std::min(10ll, INF - now));
            now += temp;
        } else {
            temp = rnd.next(1ll, std::min(10ll, now));
            now -= temp;
        }
        println(up ? '+' : '-', temp);
    }
}