#include <iostream>
#include <stack>

int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::ios_base::sync_with_stdio(0);
    int n;
    std::cin >> n;

    char command;
    unsigned int now = 0, temp;
    std::stack<unsigned int> rings;
    for (int _ = 0; _ < n; ++_) {
        std::cin >> command >> temp;

        if (!temp) {
            continue;
        }

        if (command == '+') {
            now += temp;
            while (!rings.empty() && rings.top() <= now) {
                rings.pop();
            }
            rings.emplace(now);
        } else {
            now -= temp;
            if (now) {
                rings.emplace(now);
            }
        }
        std::cout << rings.size() << '\n';
    }
}